program Laser;
{ 24.06.96: Images, Spiegeltabelle, Laserverlauf, Tastatursteuerung }
{ 30.06.96: Polfilter, Spiegeldarstellung mit Laser                 }
{ 02.07.96: Enderoutine Volltreffer, Daneben, Spiegelkaputt         }
{ 08.07.96: 10 Levels mit Lsungen, Game-Over, Highscore, Help      }
{ 10.07.96: V.1.000: Maussteuerung                                  }
{ 21.09.96: V.1.001: ein paar Sounds zum An- und Abschalten         }
uses crt,dos,graph,drivers,intuit,hiscore;

const titel='        L a s e r                 -   uja Vers.1.001             TP6.01';
      dx=24; dy=24; ox=-4; oy=12; xmax=25; ymax=16;
      imafil='laser.ima'; levelfil='laser.l';
      lsgfile='Laser.F';  hscfile='laser.hsc';

      pal:array[0..15,0..2] of word=(
      (  0,  0,  0),( 31, 41, 39),( 15, 20, 19),( 47, 63, 60),
      ( 31,  0, 17),( 63,  0, 35),( 31, 31, 31),( 47, 47, 47),
      ( 63, 63, 63),( 60, 63, 38),( 10, 21, 21),(  1, 29, 29),
      (  4, 37, 37),(  8, 46, 46),( 14, 54, 54),( 21, 63, 63));

      tabelle1:array[0..7,1..16] of integer=(
      ( 0, 1, 2, 3, 4, 5, 6, 7, 0,-1,-1,-1,-1,-1,-1,-1),
      (-1,-1, 1, 2, 3, 4, 5, 6, 7, 0, 1,-1,-1,-1,-1,-1),
      (-1,-1,-1,-1, 2, 3, 4, 5, 6, 7, 0, 1, 2,-1,-1,-1),
      (-1,-1,-1,-1,-1,-1, 3, 4, 5, 6, 7, 0, 1, 2, 3,-1),
      ( 4,-1,-1,-1,-1,-1,-1,-1, 4, 5, 6, 7, 0, 1, 2, 3),
      ( 3, 4, 5,-1,-1,-1,-1,-1,-1,-1, 5, 6, 7, 0, 1, 2),
      ( 2, 3, 4, 5, 6,-1,-1,-1,-1,-1,-1,-1, 6, 7, 0, 1),
      ( 1, 2, 3, 4, 5, 6, 7,-1,-1,-1,-1,-1,-1,-1, 7, 0));

type feld=array[0..succ(xmax),0..succ(ymax)] of integer;

var ch                     :char;
    punkte,pges            :longint;
    ok,ende,zaund          :boolean;
    ima                    :array[1..48] of Image;
    igad                   :array[1..9] of Gadget;
    itext1,itext2          :array[1..8] of Intuitext;
    ibord1,ibord2          :Border;
    xy1,xy2                :Koords;
    nlaser,code,level,cx,cy,x0,y0,g,mx,my:integer;
    f                      :feld;
    levelname              :string;
    hsc                    :highscore;



procedure brutzel;
var i,j:integer;
begin
for i:=1 to 1000 do begin
   sound(random(i)*7);
   delay(1)
end;
nosound;
end;

procedure zisch;
var i,j:integer;
begin
for i:=0 to 500 do begin
   sound(random(i div 50)+2500);
   delay(1)
end;
nosound;
end;


procedure sirene1;
var i,j:integer;
begin
for i:=1 to 200 do begin
   sound((i mod 50)+200);
   delay(12)
end;
nosound;
end;

procedure sirene2;
var i,j:integer;
begin
for i:=1 to 250 do begin
   sound(200-(i mod 50));
   delay(12)
end;
nosound;
end;

procedure fanfare;
var i,j:integer;
begin
for i:=0 to 500 do begin
   sound(random(i div 50 +100)+400);
   delay(1)
end;
nosound;
end;

{ ------------------------------------------------------------------------ }

procedure getimages;
var i,j,k:integer;
    anz  :word;
    fh   :file;
begin
   assign(fh,imafil);
   reset(fh,1);
   BlockRead(fh,ima[1],sizeof(image),anz);
   anz:=Imagesize(1,1,ima[1].width,ima[1].height);
   GetMem(ima[1].p_data,anz);
   BlockRead(fh,ima[1].p_data^,anz,anz);
   close(fh);
   putimage(0,0,ima[1].p_data^,normalput);
   FreeMem(ima[1].p_data,anz);
   k:=0;
   for j:=1 to 3 do for i:=1 to 16 do begin
      inc(k);
      with ima[k] do begin
           width:=dx; height:=dy;
           x:=0;
           y:=0;
           anz:=Imagesize(1,1,width,height);
           Getmem(p_data,anz);
           GetImage(pred(i)*dx,pred(j)*dy,pred(i*dx),pred(j*dy),p_data^);
      end;
   end;
end;

{ ------------------------------------------------------------------------ }

procedure setcolors;
var i:integer;
begin
for i:=0 to 15 do setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
for i:=0 to 15 do setpalette(i,i);
end;

{ ------------------------------------------------------------------------ }

procedure initgadgets;
var i,j,k:integer;
begin
itext1[1].itext:='Hilfe ';
itext1[2].itext:='22.5->';
itext1[3].itext:='22.5<-';
itext1[4].itext:='Schu!';
itext1[5].itext:=' Alt  ';
itext1[6].itext:=' Neu  ';
itext1[7].itext:=' Quit ';
itext1[8].itext:='Sound ';
for i:=1 to 8 do begin
   with itext1[i] do begin
      x:=8;
      y:=4;
      fpen:=9;
      bpen:=-1;
      drmode:=jam1;
      p_nexttext:=addr(itext2[i]);
   end;
   with itext2[i] do begin
      x:=itext1[i].x-1;
      y:=itext1[i].y;
      fpen:=0;
      bpen:=itext1[i].bpen;
      drmode:=itext1[i].drmode;
      itext:=itext1[i].itext;
      p_nexttext:=nil;
   end;
end;

xy1[0]:=0; xy1[1]:=15; xy1[2]:=0;  xy1[3]:=0;  xy1[4]:=55; xy1[5]:=0;
xy2[0]:=0; xy2[1]:=15; xy2[2]:=55; xy2[3]:=15; xy2[4]:=55; xy2[5]:=1;
with ibord1 do begin
      x:=0; y:=0; fpen:=9; bpen:=6; drmode:=jam2; ecken:=3;
      p_ecken:=addr(xy1);
      p_nextborder:=addr(ibord2);
end;
with ibord2 do begin
      x:=0; y:=0; fpen:=0; bpen:=6; drmode:=jam1; ecken:=3;
      p_ecken:=addr(xy2);
      p_nextborder:=nil;
end;

for i:=1 to 8 do with igad[i] do begin
      id:=i;
      if i<8 then x:=56*i+176 else x:=176;
      y:=432;
      width:=56; height:=16; bpen:=6; hibpen:=bpen;
      if i=8 then bpen:=10;
      p_loborder:=addr(ibord1);
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=p_loimage;
      p_lointuitext:=addr(itext1[i]);
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=Boolgadget;
      onoff:=false;
      if i=8 then onoff:=zaund;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
end;
i:=9;
with igad[i] do begin
      id:=i;
      x:=ox+dx; y:=oy+dy;
      width:=xmax*dx; height:=ymax*dy; bpen:=-1; hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=p_loimage;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=Boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=nil;
end;
end;

{ ------------------------------------------------------------------------ }

procedure zeichnescreen;
var i:integer;
begin
rectfill(0,0,639,479,10);
rectfill(8,8,637,24,0);
rectfill(8,460,637,475,0);
rectfill(4,4,631,20,6);
rectfill(4,456,631,471,6);
setcolor(9);
line(4,4,631,4); line(4,4,4,20); line(4,456,631,456); line(4,456,4,471);
setcolor(11);
line(4,20,631,20);   line(631,4,631,20);
line(4,471,631,471); line(631,457,631,471);
setcolor(9);
outtextxy(9,10,titel);
setcolor(0);
outtextxy(8,10,titel);
end;

{ ------------------------------------------------------------------------ }

procedure ladelevel(var level,x0,y0:integer; var levelname:string; var f:feld);
const code='#0123456789ABCDEFLZKPQRST';
      t:array[0..ymax] of string=('Pi pa po, nix mehr do!',
      'Z#######T##5####9########',
      '####Q#######QPRS#########',
      '#########K###1#####1#####',
      '####8####################',
      'T#######T###S######T#####',
      '####E####################',
      '#####          ##########',
      '##D##          #####5####',
      '##K##          ##K#######',
      '####F          ##########',
      '0##############1###2#####',
      '#########P###############',
      '#######A#############7###',
      '####3#####Q###R##########',
      '###################8#####',
      '1###T#####A#############L');

var i,j,k:integer;
    temp :string;
    fh   :text;
    err  :boolean;
begin
   for i:=0 to succ(xmax) do for j:=0 to succ(ymax) do f[i,j]:=-1;
   str(level:2,temp);
   if temp[1]=' ' then temp[1]:='0';
   temp:=levelfil+temp;
{$i-}
   assign(fh,temp);
   reset(fh);
   err:=ioresult<>0;
   if err then begin levelname:=t[0]; level:=0 end else readln(fh,levelname);
   for j:=1 to ymax do begin
      if err then temp:=t[j] else readln(fh,temp);
      for i:=1 to length(temp) do begin
         f[i,j]:=pred(pos(temp[i],code));
         if f[i,j]=17 then begin x0:=i; y0:=j; end;
      end;
   end;
   if not err then close(fh);
{$i+}
end;

{ ------------------------------------------------------------------------ }

procedure markiere(x,y:integer);
var x1,y1,x2,y2:integer;
begin
setcolor(4);
x1:=x*dx+ox; y1:=y*dy+oy; x2:=x1+pred(dx); y2:=y1+pred(dy);
line(x1,y1,x1,y2); line(x1,y2,x2,y2); line(x2,y2,x2,y1); line(x2,y1,x1,y1);
inc(x1); inc(y1); dec(x2); dec(y2);
setcolor(9);
line(x1,y1,x1,y2); line(x1,y2,x2,y2); line(x2,y2,x2,y1); line(x2,y1,x1,y1);
end;

{ ------------------------------------------------------------------------ }

procedure normal(i,j,z:integer);
var k:integer;
begin
case z of
    -1: k:=43;       { nix  }
     0: k:=17;       { leer }
 1..16: k:=f[i,j];   { Spiegel }
    17: k:=27;       { Laser }
    18: k:=21;       { Ziel  }
    19: k:=18;       { Kugel }
20..23: k:=f[i,j]+3; { Polarisatoren }
    24: k:=19;       { Bonus}
end;
putimage(i*dx+ox,j*dy+oy,ima[k].p_data^,normalput);
end;

{ ------------------------------------------------------------------------ }

procedure showges(pkt:longint);
var temp:string;
begin
   rectfill(565,458,625,468,6);
   str(pkt:7,temp);
   setcolor(9); outtextxy(565,460,temp);
   setcolor(0); outtextxy(564,460,temp);
end;

{ ------------------------------------------------------------------------ }

procedure showpunkte(punkte:longint);
var temp:string;
begin
   rectfill(416,458,480,468,6);
   str(punkte:6,temp);
   setcolor(9); outtextxy(417,460,temp);
   setcolor(0); outtextxy(416,460,temp);
end;

{ ------------------------------------------------------------------------ }

procedure zeichnefeld(level:integer; levelname:string; var f:feld);
var i,j,k:integer;
    temp :string;
begin
for j:=1 to ymax do for i:=1 to xmax do normal(i,j,f[i,j]);
str(level:2,temp);
rectfill(8,460,629,469,6);
temp:='Level: '+temp+' - '+levelname;
setcolor(9); outtextxy(13,460,temp);
setcolor(0);  outtextxy(12,460,temp);
temp:='-  Punkte:          -   ges.:       ';
setcolor(9); outtextxy(329,460,temp);
setcolor(0);  outtextxy(328,460,temp);
showpunkte(punkte);
showges(pges);
end;

{ ------------------------------------------------------------------------ }

procedure drehe(x,y,i:integer; var f:feld);
begin
   if (f[x,y]>0) and (f[x,y]<17) then begin
      f[x,y]:=f[x,y]+i;
      if f[x,y]>16 then f[x,y]:=f[x,y]-16;
      if f[x,y]<1  then f[x,y]:=f[x,y]+16;
   end;
   normal(x,y,f[x,y]);
   markiere(x,y);
end;

{ ------------------------------------------------------------------------ }

procedure movecursor(var x,y:integer; ri:integer);
var i:integer;
begin
   normal(x,y,f[x,y]);
   case ri of
   0: if x<xmax then inc(x);
   1: if y<ymax then inc(y);
   2: if x>1 then dec(x);
   3: if y>1 then dec(y);
   end;
   markiere(x,y);
end;

{ ------------------------------------------------------------------------ }

procedure goforit(var code,x,y:integer);
var x1,y1,x2,y2,ri,rin:integer;
begin
   x1:=x0;
   y1:=y0;
   x2:=x1;
   y2:=y1;
   ri:=4;
   code:=-1;
   setcolor(5);
   while code<0 do begin
      case ri of
      0: x2:=succ(x1);
      1: begin x2:=succ(x1); y2:=pred(y1); end;
      2: y2:=pred(y1);
      3: begin x2:=pred(x1); y2:=pred(y1); end;
      4: x2:=pred(x1);
      5: begin x2:=pred(x1); y2:=succ(y1); end;
      6: y2:=succ(y1);
      7: begin x2:=succ(x1); y2:=succ(y1); end;
      end;
      case f[x2,y2] of
          -1: begin code:=0; punkte:=punkte+1; end;
      0,20..23: begin
              if f[x2,y2]>19 then begin
                 case f[x2,y2] of
                 20: if (ri<>2) and (ri<>6) then code:=4;
                 21: if (ri<>3) and (ri<>7) then code:=4;
                 22: if (ri<>0) and (ri<>4) then code:=4;
                 23: if (ri<>1) and (ri<>5) then code:=4;
                 end;
                 if code>0 then begin
                    x:=x2; y:=y2;
                 end else punkte:=punkte+20;
              end;
              if code<0 then begin
              inc(punkte);
              case ri of
              0: line(x1*dx+ox+dx,y1*dy+oy+dy div 2,x2*dx+ox+dx,y2*dy+oy+dy div 2);
              1: line(x1*dx+ox+dx,y1*dy+oy,x2*dx+ox+dx,y2*dy+oy);
              2: line(x1*dx+ox+dx div 2,y1*dy+oy,x2*dx+ox+dx div 2,y2*dy+oy);
              3: line(x1*dx+ox,y1*dy+oy,x2*dx+ox,y2*dy+oy);
              4: line(x1*dx+ox,y1*dy+oy+dy div 2,x2*dx+ox,y2*dy+oy+dy div 2);
              5: line(x1*dx+ox,y1*dy+oy+dy,x2*dx+ox,y2*dy+oy+dy);
              6: line(x1*dx+ox+dx div 2,y1*dy+oy+dy,x2*dx+ox+dx div 2,y2*dy+oy+dy);
              7: line(x1*dx+ox+dx,y1*dy+oy+dy,x2*dx+ox+dx,y2*dy+oy+dy);
              end;
              end;
              end;
       1..16: begin
                 rin:=tabelle1[ri,f[x2,y2]];
                 if rin<0 then begin
                    code:=1;
                    x:=x2;
                    y:=y2;
                 end else begin
                    case ri of
                    0: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox,y2*dy+oy+dy div 2);
                    1: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox,y2*dy+oy+dy);
                    2: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox+dx div 2,y2*dy+oy+dy);
                    3: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox+dx,y2*dy+oy+dy);
                    4: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox+dx,y2*dy+oy+dy div 2);
                    5: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox+dx,y2*dy+oy);
                    6: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox+dx div 2,y2*dy+oy);
                    7: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox,y2*dy+oy);
                    end;
                    case rin of
                    0: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox+dx,y2*dy+oy+dy div 2);
                    1: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox+dx,y2*dy+oy);
                    2: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox+dx div 2,y2*dy+oy);
                    3: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox,y2*dy+oy);
                    4: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox,y2*dy+oy+dy div 2);
                    5: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox,y2*dy+oy+dy);
                    6: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox+dx div 2,y2*dy+oy+dy);
                    7: line(x2*dx+ox+dx div 2,y2*dy+oy+dy div 2,x2*dx+ox+dx,y2*dy+oy+dy);
                    end;
                    ri:=rin;
                    punkte:=punkte+10;
                 end;
              end;
          17: begin
                 code:=2;
                 x:=x2;
                 y:=y2;
              end;
          18: begin
                 code:=3;
                 putimage(x2*dx+ox,y2*dy+oy,ima[22].p_data^,normalput);
                 x:=x2;
                 y:=y2;
              end;
          19: ri:=(ri+4) mod 8;
          24: begin
                 punkte:=punkte+50;
                 putimage(x2*dx+ox,y2*dy+oy,ima[20].p_data^,normalput);
              end;
      end;
      x1:=x2;
      y1:=y2;
   end;
end;

{ ------------------------------------------------------------------------ }

procedure roeten;
var i:integer;
    temp:string;
begin
for i:=1 to 14 do setrgbpalette(i,pal[i,0],0,0);
i:=random(7);
case i of
0: temp:='                 Datt ging abba schwer ins Abseits!';
1: temp:=' Wenn Du so weitermachst, hast Du den Hintergrund bald durchgeschmort!';
2: temp:='           Du sollst die Lampe treffen, nicht den Screen!';
3: temp:='                    Datt wa woll nix, wie?';
4: temp:='                       Satz mit x ...';
5: temp:=' Spieglein, Spieglein auf dem Screen, wo sollte dieser Strahl wohl hin?';
6: temp:='            ... haarscharf daneben ist auch daneben!';
end;
rectfill(30,230,610,260, 8);
rectfill(31,231,609,259, 4);
rectfill(32,232,608,258, 0);
setcolor( 3); outtextxy(34,240,temp);
setcolor( 5); outtextxy(33,240,temp);
setcolor(15); outtextxy(32,240,temp);
punkte:=0;
showpunkte(punkte);
end;

{ ------------------------------------------------------------------------ }

procedure blaeuen;
var i:integer;
    temp:string;
begin
putimage(dx+ox,428,ima[48].p_data^,normalput);
for i:=1 to 14 do setrgbpalette(i,0,0,pal[i,2]);
temp:='         ***   G   A   M   E           O   V   E   R   ***';
rectfill(30,230,610,260, 8);
rectfill(31,231,609,259, 0);
rectfill(32,232,608,258,10);
setcolor( 3); outtextxy(34,240,temp);
setcolor( 5); outtextxy(33,240,temp);
setcolor(15); outtextxy(32,240,temp);
punkte:=0;
showpunkte(punkte);
end;

{ ------------------------------------------------------------------------ }

procedure volltreffer;
var i,j :integer;
    temp:string;
begin
showpunkte(punkte);
pges:=punkte+pges;
showges(pges);
for i:=1 to 14 do setrgbpalette(i,pal[i,0],pal[i,1],16);
i:=random(3);
case i of
0: temp:='                       Y A B B A D A B B A D O O O !';
1: temp:='                           Spot an, Jaaaaa!';
2: temp:='                             Make My Day!';
end;
rectfill(30,230,610,260, 8);
rectfill(31,231,609,259, 0);
rectfill(32,232,608,258,10);
setcolor( 0); outtextxy(36,240,temp);
setcolor( 5); outtextxy(32,240,temp);
setcolor( 8); outtextxy(33,240,temp);
for j:=1 to 10 do begin
   for i:=1 to 14 do setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
   for i:=1 to 14 do setrgbpalette(i,pal[i,0],pal[i,1],16);
end;
for i:=1 to 14 do setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
end;

{ ------------------------------------------------------------------------ }

procedure laserkaputt(x,y:integer);
var i:integer;
begin
   for i:=27 to 31 do begin
      putimage(x*dx+ox,y*dy+oy,ima[i].p_data^,normalput);
      if zaund then sound(random(5000));
      delay(100);
      nosound;
   end;
   for i:=36 to 42 do begin
      putimage(x*dx+ox,y*dy+oy,ima[i].p_data^,normalput);
      if zaund then sound(30);
      delay(100);
      nosound;
   end;
   punkte:=0;
   pges:=pges-100;
   showges(pges);
end;

{ ------------------------------------------------------------------------ }

procedure spiegelkaputt(x,y:integer);
var i:integer;
begin
   for i:=33 to 35 do begin
      putimage(x*dx+ox,y*dy+oy,ima[i].p_data^,normalput);
      if zaund then sound(random(5000));
      delay(100);
      nosound;
   end;
   for i:=33 to 35 do begin
      putimage(x*dx+ox,y*dy+oy,ima[i].p_data^,normalput);
      if zaund then sound(random(5000));
      delay(100);
      nosound;
   end;
   for i:=36 to 42 do begin
      putimage(x*dx+ox,y*dy+oy,ima[i].p_data^,normalput);
      if zaund then sound(30);
      delay(100);
      nosound;
   end;
   punkte:=0;
   pges:=pges-100;
   f[x,y]:=0;
   showges(pges);
end;

{ ------------------------------------------------------------------------ }

procedure initgame;
var i:integer;
begin
      cx:=x0;
      cy:=y0;
      punkte:=0;
      zeichnefeld(level,levelname,f);
      for i:=1 to 6 do
      if i<=nlaser then putimage(i*dx+ox,428,ima[32].p_data^,normalput)
                   else putimage(i*dx+ox,428,ima[48].p_data^,normalput);
      movecursor(cx,cy,4);
      ende:=false;
end;

{ ------------------------------------------------------------------------ }

procedure savelsg(level:integer);
var i,j,k:integer;
    fh   :text;
    temp:string;
begin
str(level:2,temp);
if level<10 then temp[1]:='0';
temp:=lsgfile+temp;
assign(fh,temp);
rewrite(fh);
for j:=1 to ymax do for i:=1 to xmax do
if (f[i,j]<17) and (f[i,j]>0) then writeln(fh,i:5,j:5,f[i,j]:5);
close(fh);
end;

{ ------------------------------------------------------------------------ }

procedure ladelsg(level:integer);
var i,j,k:integer;
    fh   :text;
    temp :string;
begin
str(level:2,temp);
if level<10 then temp[1]:='0';
temp:=lsgfile+temp;
assign(fh,temp);
{$i-}
reset(fh);
if ioresult=0 then begin
   while not eof(fh) do begin
      readln(fh,i,j,k);
      f[i,j]:=k;
      putimage(i*dx+ox,j*dy+oy,ima[k].p_data^,normalput);
   end;
   close(fh);
end;
{$i+}
end;

{ ------------------------------------------------------------------------ }

procedure helpscreen;
var i,j,k:integer;
    temp :string;
begin
   rectfill(ox+dx,oy+dy,pred(ox+xmax*dx+dx),pred(oy+ymax*dy+dy),6);
   setcolor(9);
   line(ox+dx,oy+dy,ox+xmax*dx+pred(dx),oy+dy);
   line(ox+dx,oy+dy,ox+dx,oy+ymax*dy+pred(dy));
   setcolor(0);
   line(ox+dx*xmax+pred(dx),oy+dy+1,ox+dx*xmax+pred(dx),oy+dy*ymax+pred(dy));
   line(ox+dx,oy+dy*ymax+pred(dy),ox+dx*xmax+pred(dx),oy+dy*ymax+pred(dy));
   j:=oy+dy;
   for i:=1 to 21 do begin
      case i of
      1..2,8,11,21     : j:=j+dy;
      9,12             : j:=j+16;
      3..7,10,13..20: j:=j+12;
      end;
      case i of
      1: temp:=' --- L A S E R : ---';
      2: temp:='Ziel bei Laser ist es, mit einem Laserstrahl eine Lampe zu treffen';
      3: temp:='und dadurch anzuznden. Um den Strahl zu lenken, stehen eine Reihe';
      4: temp:='Spiegel zur Verfgung sowie ein paar Metallkugeln und Polarisatoren';
      5: temp:='im Weg. Zwischendurch kann man Extrapunkte durch das Anznden wei-';
      6: temp:='terer Lampen erhalten. Bei jedem (mitgeliefertem) Level ist es mg-';
      7: temp:='lich, alle Spiegel zu verwerten.';
      8: temp:='Punkte:';
      9: temp:='pro verwendetem Feld: 1, pro Spiegel: 10, pro Polarisator: 20,';
     10: temp:='pro Bonuslampe 50 bei jedem Durchgang';
     11: temp:='Steuerung per Tastatur:                          Maussteuerung:';
     12: temp:='zu den Feldern       :  [Cursortasten]           Position anklicken';
     13: temp:='Spiegel links  drehen:  [Space]     dreht 22.5  [22.5->]';
     14: temp:='Spiegel rechts drehen:  [Backspace] dreht 22.5  [22.5<-]';
     15: temp:='Laser abfeuern       :  [enter]                  [ Schu!]';
     16: temp:='Level von vorne      :  [A]                      [  Alt  ]';
     17: temp:='Spiel von vorne      :  [N]                      [  Neu  ]';
     18: temp:='Beenden              :  [esc] oder [Q]           [  Quit ]';
     19: temp:='Hiscoreliste einsehen:  [H]';
     20: temp:='Sound ein/ausschalten:  [S]';
     21: temp:='                                            ... zum Spiel: [Taste]';
     end;
     outtextxy(pred(2*dx+ox),j,temp);
  end;
  ch:=#1;
  repeat
  showmouse;
  delay(50);
  getgadget(addr(igad[1]),g,mx,my);
  hidemouse;
  if keypressed then ch:=readkey;
  until (g>0) or (ch<>#1);
end;

{ ======================================================================== }

begin
   initscreen(ok);
   if ok then begin
      zaund:=true;
      setcolors;
      getimages;
      initgadgets;
      zeichnescreen;
      RefreshGadgets(addr(igad[1]));
      loadhighscore(hscfile,hsc);
      nlaser:=3;
      level:=1;
      ladelevel(level,x0,y0,levelname,f);
      pges:=0;
      initgame;
      while not ende do begin
         showmouse;
         delay(50);
         getgadget(addr(igad[1]),g,mx,my);
         hidemouse;
         if keypressed then begin
            ch:=readkey;
            case ch of
            #0          : begin
                             ch:=readkey;
                             case ch of
                             #59: g:=1;
                             #72: movecursor(cx,cy,3);
                             #75: movecursor(cx,cy,2);
                             #77: movecursor(cx,cy,0);
                             #80: movecursor(cx,cy,1);
                             end;
                          end;
            #8          : g:=3;
            #13         : g:=4;
            #27,'Q','q' : g:=7;
            #32         : g:=2;
            'A','a'     : g:=5;
            'H','h'     : begin
                             updathighscore(pges,hscfile,hsc,8*dx+ox,5*dy+oy,14,6,9,0,7);
                             repeat until keypressed;
                             initgame;
                          end;
            'L','l'     : ladelsg(level);
            'N','n'     : g:=6;
            'G','g'     : savelsg(level);
            'S','s'     : begin
                             zaund:=not zaund;
                             igad[8].onoff:=zaund;
                             DrawGadget(addr(igad[8]));
                          end;
            'X','x'     : drehe(cx,cy,2,f);
            'Y','y'     : drehe(cx,cy,-2,f);
            '+'         : begin
                             inc(level);
                             g:=5;
                          end;
            '-'         : begin
                             dec(level);
                             g:=5;
                          end;
            end;
         end;
         if g>0 then case g of
         1: begin
               helpscreen;
               initgame;
            end;
         2: drehe(cx,cy, 1,f);
         3: drehe(cx,cy,-1,f);
         4: begin
                 code:=0;
                 goforit(code,cx,cy);
                 if zaund then zisch;
                 case code of
                 0: begin
                    punkte:=punkte-100;
                    roeten;
                    if zaund then sirene2;
                    delay(2000);
                    setcolors;
                    initgame;
                    end;
                 1,4: begin
                         if zaund then zisch;
                         spiegelkaputt(cx,cy);
                      end;
                 2: begin
                    laserkaputt(cx,cy);
                    if zaund then zisch;
                    dec(nlaser);
                    end;
                 3: begin
                       volltreffer;
                       if zaund then fanfare;
                       delay(3000);
                       inc(level);
                       ladelevel(level,x0,y0,levelname,f);
                    end;
                 end;
                 if nlaser<1 then begin
                    blaeuen;
                    if zaund then sirene2;
                    delay(2000);
                    setcolors;
                    updathighscore(pges,hscfile,hsc,8*dx+ox,5*dy+oy,14,6,9,0,7);
                    punkte:=0;
                    nlaser:=3;
                    level:=1;
                    ladelevel(level,x0,y0,levelname,f);
                 end;
                 if not ende then initgame;
                 end;
         5: begin
               pges:=0;
               ladelevel(level,x0,y0,levelname,f);
               initgame;
            end;
         6: begin
               pges:=0;
               level:=1;
               ladelevel(level,x0,y0,levelname,f);
               initgame;
            end;
         7: ende:=true;
         8: begin
               zaund:=not zaund;
               igad[g].onoff:=zaund;
               DrawGadget(addr(igad[g]));
            end;
         9: begin
               normal(cx,cy,f[cx,cy]);
               cx:=(mx-ox) div dx;
               cy:=(my-oy) div dy;
               markiere(cx,cy);
            end;

         end;
      end;
   end;
   textmode(3);
end.

